rm(list = ls())
#####library#######
library(tidyverse)
library(raster)
library(corrplot)
library(ggplot2)
library(ENMeval)
library(rJava)
library(RColorBrewer)
library(rgdal)
library(ggrepel)
library(ggpubr)
library(vegan)
library(factoextra)
library(FactoMineR)
library(psych)
library(ggbiplot)
#automatically setting working directory (where you open this R file
#, your working directory will be set there)
setwd(dirname(rstudioapi::getActiveDocumentContext()$path))
q <- read.csv("geo.csv", header = TRUE)
y <-q[,c(2,3)]
coordinates(y)<-~Longitude+Latitude
#####extract bio
envcur2 <- data.frame(
  bio1cur = extract(x = raster("bio1.asc"), y),
  bio12cur = extract(x = raster("bio12.asc"), y))
write.csv(envcur2,"bio1-12.csv")



rm(list = ls())
###library
library(readxl)
library(plotbiomes)
library(tidyverse)
library(raster)
library(ENMeval)
library(rJava)
library(maps)
library(mapdata)
library(ggrepel)
library(ggpubr)
library(metafor)
library(glmulti)
library(multcomp)

#automatically setting working directory (where you open this R file
#, your working directory will be set there)
setwd(dirname(rstudioapi::getActiveDocumentContext()$path))
#read
d2<-read_csv("SGDC.csv")
world_map <- map_data("world")
FIGURE1a <-ggplot()+ 
  coord_fixed() +
  xlab("") + ylab("")+
  geom_map(dat = world_map, map = world_map, 
           aes(map_id=region), 
           colour = "black", fill = "#fed976", size = 0.2) +
  expand_limits(x = c(-170, 177), y = c(-54, 90))+
  theme(panel.grid = element_blank(),
        panel.background = element_rect(fill = 'lightskyblue', colour = 'lightskyblue'), 
        axis.line = element_blank(), 
        legend.position  =  c(0.12, 0.3),
        legend.text = element_text(size = 9),
        legend.background = element_blank(),
        legend.key = element_blank(),
        axis.ticks=element_blank(), 
        axis.text.x=element_blank(),
        axis.text.y=element_blank())+
  geom_point(data = d2,aes(x=Longitude,y=Latitude
                             , fill=Ecosystem),shape=21,size=3,col="black")
FIGURE1a
####Biomes
FIGURE1b <-whittaker_base_plot()+
  fill_palette("BrBG")+
  theme(legend.position=c(0.25,0.67))+
  theme(legend.background = element_blank())+
  labs(fill="Whittaker biomes")+
  geom_point(data = d2,aes(x=MAT,y=MAP),shape=21,size=3, fill="red3")+
  theme_bw()
FIGURE1b


#cumulative effect size
random1<-rma.mv(yi,vi, data=d2,random = list(~1|Species/Reference), method="REML")
summary(random1)
attach(d2)
fd3<- d2[order(-yi),] 
attach(fd3)
#FIGURES1
forest(yi, vi, annotate=F, col="grey", slab=NA,
       xlab="Fisher’s Z", pch=20,efac=0,font=2,cex=1,psize=1,
       xlim=c(-2,2), lty=c("solid","blank"))
addpoly(random1, mlab=NA, efac=1,annotate=FALSE, cex=1)
abline(v=coef(random1), lty="solid",col="red", lwd=2) 
abline(v=0, lty="dotted",col="red") 
kk<-295
points(fd3$yi, kk:1, pch=19, cex=0.5)
#group
#Is it discrete
D_Y<-rma.mv(yi,vi, data=subset(d2,D=="Y"),
            random = list(~1|Species/Reference), method="REML")
D_N<-rma.mv(yi,vi, data=subset(d2,D=="N"),
            random = list(~1|Species/Reference), method="REML")
##for better graph
a<-cbind.data.frame(D_Y$b,D_Y$pval,D_Y$ci.lb,D_Y$ci.ub)
colnames(a)<-c("estimate","pval","ci.lb","ci.ub")
b<-cbind.data.frame(D_N$b,D_N$pval,D_N$ci.lb,D_N$ci.ub)
colnames(b)<-c("estimate","pval","ci.lb","ci.ub")
Total_A<-rbind.data.frame(a,b)
row.names(Total_A)<-c("Y","N")
MyColour <- c("#0073C2FF", "#EFC000FF")
FIGURE2a<-ggplot(Total_A) + 
  geom_point(aes(y=row.names(Total_A), x=estimate, color = (ci.ub  < 0 | ci.lb  > 0)),
             shape = 15, size = 3.5)+
  geom_errorbar(aes(y=row.names(Total_A),xmin=ci.lb , xmax=ci.ub, color = (ci.ub  < 0 | ci.lb  > 0)), 
                width = 0, size = 1)+
  scale_color_manual(values = MyColour) +
  geom_vline(xintercept = 0,linetype=2)+
  xlab("")+ylab("") +
  theme_bw()+ theme(axis.line = element_line(colour = "black"), panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.background = element_blank())+
  theme(strip.background = element_blank(), strip.placement = "outside")+
  theme(legend.position="none")
FIGURE2a
#Ecosystem
Ecosystem_Forest<-rma.mv(yi,vi, data=subset(d2,Ecosystem=="Forest"),
                      random = list(~1|Species/Reference), method="REML")
Ecosystem_Grassland<-rma.mv(yi,vi, data=subset(d2,Ecosystem=="Grassland")
                         ,random = list(~1|Species/Reference), method="REML")
Ecosystem_Island<-rma.mv(yi,vi, data=subset(d2,Ecosystem=="Island"),
                      random = list(~1|Species/Reference), method="REML")
Ecosystem_Wetland<-rma.mv(yi,vi, data=subset(d2,Ecosystem=="Wetland"),
                       random = list(~1|Species/Reference), method="REML")
##for better graph
d<-cbind.data.frame(Ecosystem_Forest$b,Ecosystem_Forest$pval,
                    Ecosystem_Forest$ci.lb,Ecosystem_Forest$ci.ub)
colnames(d)<-c("estimate","pval","ci.lb","ci.ub")
e<-cbind.data.frame(Ecosystem_Grassland$b,Ecosystem_Grassland$pval,
                    Ecosystem_Grassland$ci.lb,Ecosystem_Grassland$ci.ub)
colnames(e)<-c("estimate","pval","ci.lb","ci.ub")
f<-cbind.data.frame(Ecosystem_Island$b,Ecosystem_Island$pval,
                    Ecosystem_Island$ci.lb,Ecosystem_Island$ci.ub)
colnames(f)<-c("estimate","pval","ci.lb","ci.ub")
i<-cbind.data.frame(Ecosystem_Wetland$b,Ecosystem_Wetland$pval,
                    Ecosystem_Wetland$ci.lb,Ecosystem_Wetland$ci.ub)
colnames(i)<-c("estimate","pval","ci.lb","ci.ub")
Total_B<-rbind.data.frame(d,e,f,i)
row.names(Total_B)<-c("Forest","Grassland","Island","Wetland")
MyColour <- c("#0073C2FF", "#EFC000FF")
FIGURE2b<-ggplot(Total_B) + 
  geom_point(aes(y=row.names(Total_B), x=estimate, color = (ci.ub  < 0 | ci.lb  > 0)),
             shape = 15, size = 3.5)+
  geom_errorbar(aes(y=row.names(Total_B),xmin=ci.lb , xmax=ci.ub, color = (ci.ub  < 0 | ci.lb  > 0)), 
                width = 0, size = 1)+
  scale_color_manual(values = MyColour) +
  geom_vline(xintercept = 0,linetype=2)+
  xlab("")+ylab("") +
  theme_bw()+ theme(axis.line = element_line(colour = "black"), panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.background = element_blank())+
  theme(strip.background = element_blank(), strip.placement = "outside")+
  theme(legend.position="none")
FIGURE2b
#species
Species.pool_Animal <-rma.mv(yi,vi, data=subset(d2,Species.pool=="Animal"), 
                          random = list(~1|Species/Reference),method="REML")
Species.pool_Plant <-rma.mv(yi,vi, data=subset(d2,Species.pool=="Plant"), 
                         random = list(~1|Species/Reference),method="REML")
j<-cbind.data.frame(Species.pool_Animal$b,Species.pool_Animal$pval,
                    Species.pool_Animal$ci.lb,Species.pool_Animal$ci.ub)
colnames(j)<-c("estimate","pval","ci.lb","ci.ub")
k<-cbind.data.frame(Species.pool_Plant$b,Species.pool_Plant$pval,
                    Species.pool_Plant$ci.lb,Species.pool_Plant$ci.ub)
colnames(k)<-c("estimate","pval","ci.lb","ci.ub")
Total_C<-rbind.data.frame(j,k)
row.names(Total_C)<-c("Animal","Plant")
FIGURE2c<-ggplot(Total_C) + 
  geom_point(aes(y=row.names(Total_C), x=estimate, color = (ci.ub  < 0 | ci.lb  > 0)),
             shape = 15, size = 3.5)+
  geom_errorbar(aes(y=row.names(Total_C),xmin=ci.lb , xmax=ci.ub, color = (ci.ub  < 0 | ci.lb  > 0)), 
                width = 0, size = 1)+
  scale_color_manual(values = "#EFC000FF") +
  geom_vline(xintercept = 0,linetype=2)+
  xlab("")+ylab("") +
  theme_bw()+ theme(axis.line = element_line(colour = "black"), panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.background = element_blank())+
  theme(strip.background = element_blank(), strip.placement = "outside")+
  theme(legend.position="none")
FIGURE2c
#molecular.marker
Molecular.marker_AFLP <-rma.mv(yi,vi, data=subset(d2,Molecular.marker=="AFLP"), 
                            random = list(~1|Species/Reference),method="REML")
Molecular.marker_Allozyme <-rma.mv(yi,vi, data=subset(d2,Molecular.marker=="Allozyme"), 
                                random = list(~1|Species/Reference),method="REML")
Molecular.marker_Microsatellite <- rma.mv(yi,vi, data=subset(d2,Molecular.marker=="Microsatellite"),
                                       random = list(~1|Species/Reference),method="REML")
Molecular.marker_mtDNA <-rma.mv(yi,vi, data=subset(d2,Molecular.marker=="mtDNA"), 
                             random = list(~1|Species/Reference),method="REML")
Molecular.marker_RAPD <-rma.mv(yi,vi, data=subset(d2,Molecular.marker=="RAPD"), 
                            random = list(~1|Species/Reference),method="REML")
l<-cbind.data.frame(Molecular.marker_AFLP$b,Molecular.marker_AFLP$pval,
                    Molecular.marker_AFLP$ci.lb,Molecular.marker_AFLP$ci.ub)
colnames(l)<-c("estimate","pval","ci.lb","ci.ub")
m<-cbind.data.frame(Molecular.marker_Allozyme$b,Molecular.marker_Allozyme$pval,
                    Molecular.marker_Allozyme$ci.lb,Molecular.marker_Allozyme$ci.ub)
colnames(m)<-c("estimate","pval","ci.lb","ci.ub")
n<-cbind.data.frame(Molecular.marker_Microsatellite$b,Molecular.marker_Microsatellite$pval,
                    Molecular.marker_Microsatellite$ci.lb,Molecular.marker_Microsatellite$ci.ub)
colnames(n)<-c("estimate","pval","ci.lb","ci.ub")
o<-cbind.data.frame(Molecular.marker_mtDNA$b,Molecular.marker_mtDNA$pval,
                    Molecular.marker_mtDNA$ci.lb,Molecular.marker_mtDNA$ci.ub)
colnames(o)<-c("estimate","pval","ci.lb","ci.ub")
p<-cbind.data.frame(Molecular.marker_RAPD$b,Molecular.marker_RAPD$pval,
                    Molecular.marker_RAPD$ci.lb,Molecular.marker_RAPD$ci.ub)
colnames(p)<-c("estimate","pval","ci.lb","ci.ub")

Total_D<-rbind.data.frame(l,m,n,o,p)
row.names(Total_D)<-c("AFLP","Allozyme","Microsatellite","mtDNA","RAPD")
FIGURE2d<-ggplot(Total_D) + 
  geom_point(aes(y=row.names(Total_D), x=estimate, color = (ci.ub  < 0 | ci.lb  > 0)),
             shape = 15, size = 3.5)+
  geom_errorbar(aes(y=row.names(Total_D),xmin=ci.lb , xmax=ci.ub, color = (ci.ub  < 0 | ci.lb  > 0)), 
                width = 0, size = 1)+
  scale_color_manual(values = MyColour) +
  geom_vline(xintercept = 0,linetype=2)+
  xlab("")+ylab("") +
  theme_bw()+ theme(axis.line = element_line(colour = "black"), panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.background = element_blank())+
  theme(strip.background = element_blank(), strip.placement = "outside")+
  theme(legend.position="none")
FIGURE2d
FIGURE2<-ggarrange(FIGURE2a,FIGURE2b,
                   FIGURE2c,FIGURE2d,
                   nrow=2,ncol=2,labels = c("a","b","c","d")) 
FIGURE2

#Introduce explanatory variables
#MAT Total
MAT <- rma.mv(yi, vi, mods = ~ MAT, 
                random = list(~1|Species/Reference), data = d2, method = "ML")
summary(MAT)

d2$MAT_T<-resid(MAT)-0.0111*d2$MAT+0.3069
d2$wi<-1/sqrt(d2$vi)
FIGURE3a<-ggplot(data = d2, aes(x = MAT, y = MAT_T)) +
  geom_point(aes(size=wi),shape = 1) +
  stat_smooth(method = lm, size = 0.8) +
  ylab("Fisher’s Z of SGDC") + 
  xlab("MAT (℃)") + 
  geom_hline(aes(yintercept = 0),linetype="dashed",colour="black") +
  theme_bw() +
  annotate("text",x = 10, y = 1.2,label = "y=-0.0111x+0.3069 P < 0.01",col="red"
           ,size=3,fontface="bold.italic")
FIGURE3a
#MAP Total
MAP <- rma.mv(yi, vi, mods = ~ MAP, 
              random = list(~1|Species/Reference), data = d2, method = "ML")
summary(MAP)
d2$MAP_T<-resid(MAP)+0.0024*d2$MAP-0.0167
FIGURE3b<-ggplot(data = d2, aes(x = MAP, y = MAP_T)) +
  geom_point(aes(size=wi),shape = 1) +
  stat_smooth(method = lm, size = 0.8) +
  ylab("Fisher’s Z of SGDC") + 
  xlab("MAP cm") + 
  geom_hline(aes(yintercept = 0),linetype="dashed",colour="black") +
  theme_bw() +
  annotate("text",x = 100, y = 1.2,label = "y=0.0024x-0.0167 P < 0.01",col="red",
           size=3,fontface="bold.italic")
FIGURE3b
#Total N
N<-rma.mv(yi, vi, mods = ~ N, 
          random = list(~1|Species/Reference), data = d2, method = "ML")
summary(N)
d2$N_T<-resid(N)-0.0036*d2$N+0.2742
FIGURE3c<-ggplot(data = d2, aes(x = N, y = N_T)) +
  geom_point(aes(size=wi),shape = 1) +
  stat_smooth(method = lm, size = 0.8) +
  ylab("Fisher’s Z of SGDC") + 
  xlab("N") + 
  geom_hline(aes(yintercept = 0),linetype="dashed",colour="black") +
  theme_bw() +
  annotate("text",x = 50, y = 1.2,label = "y=-0.0036x+0.2742 P < 0.01",
           size=3,col="red",fontface="bold.italic")
FIGURE3c


FIGURE3<-ggarrange(FIGURE3a,FIGURE3b,FIGURE3c,
                   nrow=2,ncol=2,labels = c("a","b","c")) 
FIGURE3

#Categorical variables
D<-rma.mv(yi,vi, mods= ~ -1+D, data=d2, 
       random = list(~1|Species/Reference),method="REML")

summary(D)

Ecosystem<-rma.mv(yi,vi, mods= ~ -1+Ecosystem, data=d2, 
                  random = list(~1|Species/Reference),method="REML")
summary(Ecosystem)

Species.pool<-rma.mv(yi,vi, mods= ~ -1+Species.pool, data=d2, 
                     random = list(~1|Species/Reference),method="REML")
summary(Species.pool)

Molecular.marker<-rma.mv(yi,vi, mods= ~ -1+Molecular.marker, data=d2, 
                         random = list(~1|Species/Reference),method="REML")
summary(Molecular.marker)

rma.mv(yi,vi, mods= ~ -1+Ecosystem:Species.pool, data=d2, 
       random = list(~1|Species/Reference),method="REML")

rma.mv(yi,vi, mods= ~ -1+Ecosystem:Molecular.marker, data=d2, 
       random = list(~1|Species/Reference),method="REML")

rma.mv(yi,vi, mods= ~ -1+Ecosystem:D, data=d2, 
       random = list(~1|Species/Reference),method="REML")

rma.mv(yi,vi, mods= ~ -1+D:Species.pool, data=d2, 
       random = list(~1|Species/Reference),method="REML")

rma.mv(yi,vi, mods= ~ -1+D:Molecular.marker, data=d2, 
       random = list(~1|Species/Reference),method="REML")

rma.mv(yi,vi, mods= ~ -1+Species.pool:Molecular.marker, data=d2, 
       random = list(~1|Species/Reference),method="REML")

#Model diagnosis
funnel(random1, level=c(90, 95, 99),
       shade=c("white", "gray", "darkgray"), refline=0,
       main="Standard Error")
abline(v=random1$b, lty="solid",col="red",lwd=2)


rma.mv(yi,vi, mods= ~ -1+Ecosystem:Species.pool, data=d2, 
       random = list(~1|Species/Reference),method="REML")


#Here about disscussion

#read
SGDC1<-read.csv("SGDC1.csv")

#yi,vi
d3<-escalc(measure="COR",data=SGDC1,ni=N,ri=SGDC)
#cumulative effect size
random3<-rma.mv(yi,vi, data=d3,random = list(~1|Species/Reference), method="REML")
summary(random3)
attach(d3)
fd3<- d3[order(yi),] 
attach(fd3)
#FIGURES1
forest(yi, vi, annotate=F, col="grey", slab=NA,
       xlab="Fisher’s Z", pch=20,efac=0,font=2,cex=1,psize=1,
       xlim=c(-2,2), lty=c("solid","blank"))
addpoly(random3, mlab=NA, efac=1,annotate=FALSE, cex=1)
abline(v=coef(random3), lty="solid",col="red", lwd=2) 
abline(v=0, lty="dotted",col="red") 
kk<-61
points(fd3$yi, kk:1, pch=19, cex=0.5)





